
public class Driver {
	
	
	private static final int NUMBER_OF_PERSONS = 100;
	private static final int RANDOM_MULTIPLIER = 900_000_000;

	public static void main(String[] args) {
		BinarySearchTree<Person<Integer>, Integer> bst = new BinarySearchTree<Person<Integer>, Integer>();
		Integer[] keys = new Integer[NUMBER_OF_PERSONS];
		
		for ( int i = 0 ; i < NUMBER_OF_PERSONS ; i++ ) {
			Integer key = new Integer((int) (Math.random() * RANDOM_MULTIPLIER));
			keys[i] = key;
			Person<Integer> person = new Person<Integer>(key);
			bst.insert(person);
		}
		
		TreeElementIterator<Person<Integer>, Integer> treeIterator = bst.iterator();
		treeIterator.setInOrder();
		
		System.out.println("inOrder");
		int count = 1;
		while (treeIterator.hasNext()) {
			System.out.println(count++ + " - " + treeIterator.next());
		}

		System.out.println("\n\n");
		
		System.out.println("preOrder");
		treeIterator.setPreOrder();
		count = 1;
		while (treeIterator.hasNext()) {
			System.out.println(count++ + " - " + treeIterator.next());
		}

		System.out.println("\n\n");
		
		System.out.println("postOrder");
		treeIterator.setPostOrder();
		count = 1;
		while (treeIterator.hasNext()) {
			System.out.println(count++ + " - " + treeIterator.next());
		}
		
		
		for ( int i = 0 ; i < NUMBER_OF_PERSONS ; i++ ) {
			try {
				System.out.println("Deleting Key = " + keys[i]);
				bst.delete(keys[i]);
			} catch (TreeException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.exit(-1);
			}
			
			System.out.println("\n\n\npreOrder");
			treeIterator.setPreOrder();
			count = 1;
			while (treeIterator.hasNext()) {
				System.out.println(count++ + " - " + treeIterator.next());
			}

		
		}
		
	}

}
